/***
** Copyright (C) 2012 Christophe CHAPUIS <chris.chapuis _at_ gmail _dot_ com>
**
** This package is free software; you can redistribute it and/or modify
** it under the terms of the GNU General Public License as published by
** the Free Software Foundation; either version 2 of the License, or
** (at your option) any later version.
**
** This package is distributed in the hope that it will be useful,
** but WITHOUT ANY WARRANTY; without even the implied warranty of
** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
** GNU General Public License for more details.
**
** You should have received a copy of the GNU General Public License
** along with this package; if not, write to the Free Software
** Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
**
***/
import QtQuick 1.0
import "../modelitf"

SourceModel {
    name: "Le Monde"

    listViews: [
        { viewComponent: 'content/view/Categories.qml' } ,
        { viewComponent: 'content/view/News.qml' },
        { viewComponent: 'content/view/NewsDetail.qml' },
        { viewComponent: 'content/view/NewsDetailFromURL.qml' }
    ]
    listModels: [
        categoriesModel,
        newsModel,
        newsModelDetail,
        newsModelDetailComments
    ]

    function getSeqId(categoryIndex)
    {
        if( typeof categoriesModel.get(categoryIndex) != "undefined" )
            if( typeof categoriesModel.get(categoryIndex).seqid != "undefined" )
                return categoriesModel.get(categoryIndex).seqid

        return ""
    }

    function getNewsModelItem(prop)
    {
        var newsIndex = currentPath[2]

        if( typeof newsModel.get(newsIndex) != "undefined" )
            if( typeof newsModel.get(newsIndex)[prop] != "undefined" )
                return newsModel.get(newsIndex)[prop]

        return ""
    }

    property variant categoriesModel: LeMondeSequencesList { }
    property variant newsModel: LeMondeSequenceNews {
        seqid: getSeqId(currentPath[1])
    }
    property variant newsModelDetail: QtObject {
        property variant parentModel: newsModel
        property int sourceDepth: 3

        property string urllink: getNewsModelItem('link')
        property string htmlcontent: getNewsModelItem('detailedContent')
        property string title: getNewsModelItem('title')
        property string image: getNewsModelItem('image')
    }
    property variant newsModelDetailComments: QtObject {
        property variant parentModel: newsModel
        property int sourceDepth: 4

        property string urllink: "http://www.lemonde.fr" + getNewsModelItem('commentURL')
        property string title: getNewsModelItem('title')
        property string image: getNewsModelItem('image')
    }

    loading: categoriesModel.loading || newsModel.loading
}
